"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const createPoolWithSpy_1 = require("../../../helpers.test/createPoolWithSpy");
const createTestRunner_1 = require("../../../helpers.test/createTestRunner");
const pg_driver_1 = require("@slonik/pg-driver");
const sql_tag_1 = require("@slonik/sql-tag");
const driverFactory = (0, pg_driver_1.createPgDriverFactory)();
const { test } = (0, createTestRunner_1.createTestRunner)(driverFactory, 'pg');
const sql = (0, sql_tag_1.createSqlTag)();
test('transforms query', async (t) => {
    const { pool, spy } = await (0, createPoolWithSpy_1.createPoolWithSpy)(t.context.dsn, {
        driverFactory,
        interceptors: [
            {
                transformQuery: (executionContext, query) => {
                    return {
                        ...query,
                        sql: 'SELECT 2',
                    };
                },
            },
        ],
    });
    await pool.query(sql.unsafe `SELECT 1`);
    t.is(spy.query.firstCall.args[0], 'SELECT 2');
});
//# sourceMappingURL=transformQuery.test.js.map