"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createPoolConfiguration = void 0;
const Logger_1 = require("../Logger");
const createPoolConfiguration = (clientConfiguration) => {
    const poolConfiguration = {
        idleTimeout: 10000,
        maximumPoolSize: 10,
        minimumPoolSize: 0,
    };
    if (clientConfiguration.idleTimeout !== 'DISABLE_TIMEOUT') {
        if (clientConfiguration.idleTimeout === 0) {
            Logger_1.Logger.warn('idleTimeout=0 sets timeout to 0 milliseconds; use idleTimeout=DISABLE_TIMEOUT to disable timeout');
            poolConfiguration.idleTimeout = 1;
        }
        else {
            poolConfiguration.idleTimeout = clientConfiguration.idleTimeout;
        }
    }
    if (clientConfiguration.maximumPoolSize) {
        poolConfiguration.maximumPoolSize = clientConfiguration.maximumPoolSize;
    }
    if (clientConfiguration.minimumPoolSize) {
        poolConfiguration.minimumPoolSize = clientConfiguration.minimumPoolSize;
    }
    return poolConfiguration;
};
exports.createPoolConfiguration = createPoolConfiguration;
//# sourceMappingURL=createPoolConfiguration.js.map