"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createPoolWithMockedQuery = void 0;
const createPool_1 = require("../factories/createPool");
const node_events_1 = __importDefault(require("node:events"));
const sinon = __importStar(require("sinon"));
const createPoolWithMockedQuery = async (dsn, { driverFactory, ...configuration }) => {
    const query = sinon.mock();
    let connection;
    const pool = await (0, createPool_1.createPool)(dsn, {
        driverFactory: async (...args) => {
            if (!driverFactory) {
                throw new Error('Driver is required');
            }
            const driver = await driverFactory(...args);
            return {
                createClient: async () => {
                    if (connection) {
                        return connection;
                    }
                    // We are re-using the same connection for all queries
                    // as it makes it easier to spy on the connection.
                    // eslint-disable-next-line require-atomic-updates
                    connection = await driver.createClient().then((nextConnection) => {
                        return {
                            ...nextConnection,
                            events: new node_events_1.default(),
                        };
                    });
                    // eslint-disable-next-line require-atomic-updates
                    connection.query = query;
                    return connection;
                },
            };
        },
        ...configuration,
    });
    return {
        pool,
        query,
    };
};
exports.createPoolWithMockedQuery = createPoolWithMockedQuery;
//# sourceMappingURL=createPoolWithMockedQuery.js.map