"use strict";
/* eslint-disable no-console */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const __1 = require("..");
// eslint-disable-next-line import/extensions
const termination_test_1 = require("./termination.test");
const ava_1 = __importDefault(require("ava"));
const node_child_process_1 = require("node:child_process");
/**
 * @see https://github.com/gajus/slonik/issues/631
 */
(0, ava_1.default)('releases failed connections', async (t) => {
    t.timeout(10000);
    try {
        const output = (0, node_child_process_1.execSync)('docker --version', { encoding: 'utf8' });
        console.log('Docker CLI is available:', output.trim());
    }
    catch {
        console.log('Skipper the test. Docker CLI is not available.');
        return;
    }
    const { dsn, terminate } = await (0, termination_test_1.startTestContainer)();
    const pool = await (0, __1.createPool)(dsn, {
        connectionRetryLimit: 1,
        connectionTimeout: 500,
        maximumPoolSize: 1,
    });
    terminate();
    const isConnectionAvailable = async () => {
        try {
            await pool.connect((connection) => {
                return connection.oneFirst(__1.sql.unsafe `SELECT NOW()`);
            });
            return true;
        }
        catch {
            // do nothing
        }
        return false;
    };
    t.deepEqual([await isConnectionAvailable(), await isConnectionAvailable()], [false, false]);
});
//# sourceMappingURL=lostConnection.test.js.map