import { type ConnectionPoolClient } from '../factories/createConnectionPool';
import { type ClientConfiguration, type Logger, type Query, type QueryContext, type QueryId, type QueryResult, type QueryResultRow, type StreamResult } from '../types';
import { type PrimitiveValueExpression, type QuerySqlToken } from '@slonik/sql-tag';
export type ExecutionRoutine = (connection: ConnectionPoolClient, sql: string, values: readonly PrimitiveValueExpression[], queryContext: QueryContext, query: Query) => Promise<GenericQueryResult>;
type GenericQueryResult = QueryResult<QueryResultRow> | StreamResult;
export declare const executeQuery: (connectionLogger: Logger, connection: ConnectionPoolClient, clientConfiguration: ClientConfiguration, query: QuerySqlToken, inheritedQueryId: QueryId | undefined, executionRoutine: ExecutionRoutine, stream?: boolean) => Promise<QueryResult<Record<string, PrimitiveValueExpression>> | StreamResult>;
export {};
//# sourceMappingURL=executeQuery.d.ts.map