"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPoolClientState = exports.poolClientStateMap = void 0;
const errors_1 = require("@slonik/errors");
exports.poolClientStateMap = new WeakMap();
const getPoolClientState = (poolClient) => {
    const poolClientState = exports.poolClientStateMap.get(poolClient);
    if (!poolClientState) {
        throw new errors_1.UnexpectedStateError('Pool Client state is unavailable.');
    }
    return poolClientState;
};
exports.getPoolClientState = getPoolClientState;
//# sourceMappingURL=state.js.map